//+------------------------------------------------------------------+
//|                                   exp_cci_multy_currency_mt4.mq4 |
//|                                                   Sergey Gritsay |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Sergey Gritsay"
#property link      "https://www.mql5.com"
#property version   "2.00"
#property strict

#resource "\\Include\\Controls\\res\\CloseDisable.bmp"
#resource "\\Include\\Controls\\res\\Close.bmp"
#resource "\\Include\\Controls\\res\\RestoreDisable.bmp"
#resource "\\Include\\Controls\\res\\ExpandDisable.bmp"
#resource "\\Include\\Controls\\res\\TurnOn.bmp"
#resource "\\Include\\Controls\\res\\TurnOff.bmp"

string CloseDisable="::Include\\Controls\\res\\CloseDisable.bmp";
string CloseOff="::Include\\Controls\\res\\Close.bmp";
string RollOn="::Include\\Controls\\res\\RestoreDisable.bmp";
string RollOff="::Include\\Controls\\res\\ExpandDisable.bmp";
string TurnOn="::Include\\Controls\\res\\TurnOn.bmp";
string TurnOff="::Include\\Controls\\res\\TurnOff.bmp";

#include <stderror.mqh> 
#include <stdlib.mqh> 
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
enum ENUM_TYPE_BALANS
  {
   Balance,
   Equity,
   FreeMargin
  };

input int Magic=1234567;
input ENUM_TYPE_BALANS Type_Balanse=Balance;
input double Risk=1.0;
input double Lot=0.01;
input double Loading_deposit=20.0;
input double Ksl=2.0;
input double Ktp=4.0;
input bool TrailingStop=true;
input int period_CCI_S=100;
input int period_CCI_F=13;
input int Period_ATR=21;
input ENUM_TIMEFRAMES TF_ATR=PERIOD_CURRENT;
input bool signal_01=true;
input bool signal_02=true;
input bool signal_03=true;
input bool signal_04=true;
input bool signal_05=true;
input string CommentOrder="exp_cci";
input color ColorTime=clrBlack;
input color ColorSymbol=clrGreen;
input color ColorText=clrBlack;

double LD;
int Signal[];
ENUM_ORDER_TYPE Trend[];
double SL[];
double TP[];
double volume;
datetime curbar[];
datetime lastbar[];
string rezult="";
bool MarketWatch=true;
int total_symbol;
int total_symbol2;

int Width;
int Height;

bool show_close=false;
bool show_roll = false;
bool show_turn = false;
bool show_ok=false;
string form1="form1_";
string form2="form2_";
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//---
   total_symbol=SymbolsTotal(MarketWatch);
   EventSetTimer(1);
   ArrayResize(SL,total_symbol);
   ArrayResize(TP,total_symbol);
   ArrayResize(Trend,total_symbol);
   ArrayResize(Signal,total_symbol);
   ArrayResize(curbar,total_symbol);
   ArrayResize(lastbar,total_symbol);

   ArrayInitialize(Trend,WRONG_VALUE);
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---
   EventKillTimer();
   ObjectsDeleteAll(0,form1);
   ObjectsDeleteAll(0,form2);
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
//void OnTick()
void OnTimer()
  {
   total_symbol=SymbolsTotal(MarketWatch);
   if(total_symbol2!=total_symbol)
     {
      total_symbol2=SymbolsTotal(MarketWatch);
      ArrayResize(SL,total_symbol);
      ArrayResize(TP,total_symbol);
      ArrayResize(Trend,total_symbol);
      ArrayResize(Signal,total_symbol);
      ArrayResize(curbar,total_symbol);
      ArrayResize(lastbar,total_symbol);

      ArrayInitialize(Trend,WRONG_VALUE);
     }

   LD=LoadingDeposit();

   for(int i=0;i<total_symbol;i++)
     {
      string symbol=SymbolName(i,MarketWatch);
      Signal[i]=GetSignal(symbol,Trend[i]);
      SL[i]=DynamicStop(symbol,Ksl);
      TP[i]=DynamicStop(symbol,Ktp);

      if(Risk!=0.0)volume=Volumes(symbol,Risk/(double)total_symbol,SL[i]);
      else volume=volume_n(symbol,Lot);

      if(new_bar(symbol,PERIOD_CURRENT,i))
        {
         if(Signal[i]==OP_BUY)
           {
            Order_Close(symbol,OP_SELL);
            if(Total_orders(symbol,OP_BUY)==0)OrderOpen(symbol,OP_BUY);
           }
         if(Signal[i]==OP_SELL)
           {
            Order_Close(symbol,OP_BUY);
            if(Total_orders(symbol,OP_SELL)==0)OrderOpen(symbol,OP_SELL);
           }
        }

      ModifySL(symbol,SL[i]);
      ModifyTP(symbol,TP[i]);

      if(TrailingStop)Trailing_Stop(symbol,SL[i]);
     }

   Width=ChartWidthInPixels()-20;
   Height=ChartHeightInPixelsGet();

   if(show_turn)from_create2();
   if(!show_turn)from_create1();
   if(!show_turn && !show_roll)from_create3();
   ChartRedraw(0);
  }
//+------------------------------------------------------------------+
//| ChartEvent function                                              |
//+------------------------------------------------------------------+
void OnChartEvent(const int id,
                  const long &lparam,
                  const double &dparam,
                  const string &sparam)
  {
   if(id==CHARTEVENT_OBJECT_CLICK)
     {
      if(sparam==form1+(string)1)
        {
         show_close=(int)ObjectGetInteger(0,form1+(string)1,OBJPROP_STATE);
         if(show_close)ExpertRemove();

        }

      if(sparam==form1+(string)3 || sparam==form1+(string)2)
        {
         show_turn=(int)ObjectGetInteger(0,form1+(string)3,OBJPROP_STATE);
         show_roll=(int)ObjectGetInteger(0,form1+(string)2,OBJPROP_STATE);
        }
      if(!show_turn || !show_roll)
        {
         from_create1();
         from_create3();
        }

      if(show_turn)
        {
         ObjectsDeleteAll(0);
         from_create2();
        }

      if(!show_turn)
        {
         ObjectsDeleteAll(0);
         from_create1();
        }

      if(!show_turn && !show_roll)from_create3();
      ChartRedraw(0);
     }
  }
//+------------------------------------------------------------------+
double LoadingDeposit()
  {
   double value=0.0;
   double Equity=AccountInfoDouble(ACCOUNT_EQUITY);
   double Margin=AccountInfoDouble(ACCOUNT_MARGIN);

   if(Equity!=0) value=(Margin/Equity)*100.0;
   return(value);
  }
//+------------------------------------------------------------------+
ENUM_ORDER_TYPE GetSignal(string symbol,ENUM_ORDER_TYPE &trend)
  {
   double CCI_S1=0.0;
   double CCI_S2=0.0;
   double CCI_F1=0.0;
   double CCI_F2=0.0;

   if(iBars(symbol,PERIOD_CURRENT)<period_CCI_S+1)return(WRONG_VALUE);
   int i=0;
   do
     {
      if(i>iBars(symbol,PERIOD_CURRENT))break;

      CCI_S1=iCCI(symbol,0,period_CCI_S,PRICE_CLOSE,1+i);
      CCI_S2=iCCI(symbol,0,period_CCI_S,PRICE_CLOSE,2+i);

      CCI_F1=iCCI(symbol,0,period_CCI_F,PRICE_CLOSE,1+i);
      CCI_F2=iCCI(symbol,0,period_CCI_F,PRICE_CLOSE,2+i);

      if(CCI_S1>100.0)trend=OP_BUY;
      if(CCI_S1<-100.0)trend=OP_SELL;

      if(CCI_S1>100.0  &&  CCI_S2<100.0)trend=OP_BUY;
      if(CCI_S1<-100.0 && CCI_S2>-100.0)trend=OP_SELL;
      i++;
     }
   while(trend==WRONG_VALUE && !IsStopped());

   if(trend==OP_BUY)
     {
      if(signal_01 && CCI_F1<-100.0)return(OP_BUY);
      if(signal_02 && CCI_F1<-100.0 && CCI_F2>-100.0)return(OP_BUY);
      if(signal_03 && CCI_F1>-100.0 && CCI_F2<-100.0)return(OP_BUY);
      if(signal_04 && CCI_F1>100.0 && CCI_F2<100.0)return(OP_BUY);
      if(signal_05 && CCI_F1>100.0)return(OP_BUY);
     }
   if(trend==OP_SELL)
     {
      if(signal_01 && CCI_F1>100)return(OP_SELL);
      if(signal_02 && CCI_F1>100 && CCI_F2<100)return(OP_SELL);
      if(signal_03 && CCI_F1<100 && CCI_F2>100)return(OP_SELL);
      if(signal_04 && CCI_F1<-100 && CCI_F2>-100)return(OP_SELL);
      if(signal_05 && CCI_F1<-100)return(OP_SELL);
     }

   return(WRONG_VALUE);
  }
//+------------------------------------------------------------------+
double DynamicStop(string symbol,double k)
  {
   double point=SymbolInfoDouble(symbol,SYMBOL_POINT);
   double stop_level=(double)SymbolInfoInteger(symbol,SYMBOL_TRADE_STOPS_LEVEL);
   double ts=SymbolInfoDouble(symbol,SYMBOL_TRADE_TICK_SIZE);

   if(iBars(symbol,TF_ATR)<Period_ATR+1)return(WRONG_VALUE);
   double atr=iATR(symbol,TF_ATR,Period_ATR,1);
   double volue=(atr/point)*k;

   if(volue<=stop_level)volue*=3.0;
   volue=NormalizeDouble(volue/ts,0)*ts;

   return(volue);
  }
//+------------------------------------------------------------------+
double Volumes(string symbol,double risk,double sl)
  {
   double lot=0.0;
   double procent=0.0;
   double balans=0.0;
   double tc = SymbolInfoDouble(symbol,SYMBOL_TRADE_CONTRACT_SIZE);
   double tv = SymbolInfoDouble(symbol,SYMBOL_TRADE_TICK_VALUE);
   double ts=SymbolInfoDouble(symbol,SYMBOL_TRADE_TICK_SIZE);
   double point=SymbolInfoDouble(symbol,SYMBOL_POINT);

   if(Type_Balanse==Balance) balans=AccountInfoDouble(ACCOUNT_BALANCE);
   if(Type_Balanse==Equity) balans=AccountInfoDouble(ACCOUNT_EQUITY);
   if(Type_Balanse==FreeMargin) balans=AccountInfoDouble(ACCOUNT_FREEMARGIN);

   procent=(balans/100.0)*risk;

   switch((int)MarketInfo(symbol,MODE_PROFITCALCMODE))
     {
      case 0: if(sl!=0 && point!=0 && tc!=0) lot=procent/(sl*tv);break;
      case 1: if(sl!=0 && point!=0 && tc!=0) lot=procent/(sl*point*tc);break;
      case 2: if(sl!=0 && point!=0 && tv!=0 && ts!=0) lot=procent/(sl*point*(tv/ts));break;
     }
   return(volume_n(symbol,lot));
  }
//+------------------------------------------------------------------+
double volume_n(string symbol,double lot)
  {
   double MinLot=SymbolInfoDouble(symbol,SYMBOL_VOLUME_MIN);
   double MaxLot=SymbolInfoDouble(symbol,SYMBOL_VOLUME_MAX);
   double LotStep=SymbolInfoDouble(symbol,SYMBOL_VOLUME_STEP);

   if(lot<MinLot)lot=MinLot;
   if(lot>MaxLot)lot=MaxLot;

   if(LotStep==0.001) return(NormalizeDouble(lot,3));
   if(LotStep==0.01)  return(NormalizeDouble(lot,2));
   if(LotStep==0.1)   return(NormalizeDouble(lot,1));

   return(NormalizeDouble(lot,0));
  }
//+------------------------------------------------------------------+
bool new_bar(string symbol,ENUM_TIMEFRAMES period,int i)
  {
   curbar[i]=(datetime) SeriesInfoInteger(symbol,period,SERIES_LASTBAR_DATE);
   if(lastbar[i]==0)lastbar[i]=(datetime)SeriesInfoInteger(symbol,period,SERIES_LASTBAR_DATE);
   if(lastbar[i]!=curbar[i])
     {
      lastbar[i]=curbar[i];
      return(true);
     }
   return(false);
  }
//+------------------------------------------------------------------+
void Order_Close(string symbol,int type)
  {
   double price=0.0;
   int total=OrdersTotal();
   int digits=(int)SymbolInfoInteger(symbol,SYMBOL_DIGITS);
   if(!disabled(symbol))return;
   for(int i=total-1; i>=0; i--)
     {
      if(!OrderSelect(i,SELECT_BY_POS))continue;
      if(OrderType()!=type)continue;
      if(OrderMagicNumber()!=Magic)continue;
      if(OrderSymbol()!=symbol)continue;

      if(OrderType()==OP_BUY)
        {
         RefreshRates();
         price=NormalizeDouble(SymbolInfoDouble(symbol,SYMBOL_BID),digits);
        }
      if(OrderType()==OP_SELL)
        {
         RefreshRates();
         price=NormalizeDouble(SymbolInfoDouble(symbol,SYMBOL_ASK),digits);
        }
      int res=OrderClose(OrderTicket(),OrderLots(),price,10000);
      if(res)
        {
         rezult=StringConcatenate(symbol,": close order ",DoubleToString(OrderLots(),LotDigits(OrderSymbol(),OrderLots()))," ",StrToType(OrderType())," Ticket:",OrderTicket());
         Alert(rezult);
        }
      else
        {
         int error=GetLastError();
         rezult=StringConcatenate(symbol,": error close order ",DoubleToString(OrderLots(),LotDigits(OrderSymbol(),OrderLots()))," ",StrToType(type)," - ",error," ",ErrorDescription(error));
         Print(rezult);
        }
     }
  }
//+------------------------------------------------------------------+
void OrderOpen(string symbol,int type)
  {
   double price=0.0;
   int digits=(int)SymbolInfoInteger(symbol,SYMBOL_DIGITS);
   if(!disabled(symbol))return;
   if(LD>=Loading_deposit)return;
   if(type==OP_BUY)
     {
      RefreshRates();
      price=NormalizeDouble(SymbolInfoDouble(symbol,SYMBOL_ASK),digits);
      if(AccountFreeMarginCheck(symbol,type,volume)<=0)
        {
         rezult="not enough money";
         return;
        }
     }
   if(type==OP_SELL)
     {
      RefreshRates();
      price=NormalizeDouble(SymbolInfoDouble(symbol,SYMBOL_BID),digits);
      if(AccountFreeMarginCheck(symbol,type,volume)<=0)
        {
         rezult="not enough money";
         return;
        }
     }

   int Ticket=OrderSend(symbol,type,volume,price,10000,0,0,CommentOrder,Magic);
   if(Ticket>0)
     {
      rezult=StringConcatenate(symbol,": open order ",DoubleToString(volume,LotDigits(symbol,volume))," ",StrToType(type)," Ticket:",Ticket);
      Alert(rezult);
     }
   else
     {
      int error=GetLastError();
      rezult=StringConcatenate(symbol,": error open order ",DoubleToString(volume,LotDigits(symbol,volume))," ",StrToType(type)," - ",error," ",ErrorDescription(error));
      Print(rezult);
     }
  }
//+------------------------------------------------------------------+
int Total_orders(string symbol,int type)
  {
   int n=0;
   int total=OrdersTotal();

   for(int i=0; i<total; i++)
     {
      if(!OrderSelect(i,SELECT_BY_POS))continue;
      if(OrderSymbol()!=symbol)continue;
      if(OrderMagicNumber()!=Magic)continue;
      if(OrderType()!=type)continue;
      n++;
     }
   return(n);
  }
//+------------------------------------------------------------------+
int LotDigits(string symbol,double lot)
  {
   double LotStep=SymbolInfoDouble(symbol,SYMBOL_VOLUME_STEP);
   if(LotStep==0.001) return(3);
   if(LotStep==0.01)  return(2);
   if(LotStep==0.1)   return(1);
   return(0);
  }
//+------------------------------------------------------------------+
string StrToType(int type)
  {
   if(type==OP_BUY)return("BUY");
   if(type==OP_SELL)return("SELL");
   return(NULL);
  }
//+------------------------------------------------------------------+
void ModifySL(string symbol,double Stop_Loss)
  {
   if(Stop_Loss<=0)return;
   double sl=0.0;
   bool res;
   double point=SymbolInfoDouble(symbol,SYMBOL_POINT);
   int digits=(int)SymbolInfoInteger(symbol,SYMBOL_DIGITS);
   int total=OrdersTotal();

   for(int i=0; i<total; i++)
     {
      if(!OrderSelect(i,SELECT_BY_POS))continue;
      if(OrderMagicNumber()!=Magic)continue;
      if(OrderSymbol()!=symbol)continue;
      if(OrderType()>1)continue;
      if(OrderStopLoss()!=0)continue;

      if(OrderType()==OP_BUY) sl=NormalizeDouble(SymbolInfoDouble(symbol,SYMBOL_BID)-Stop_Loss*point,digits);
      if(OrderType()==OP_SELL) sl=NormalizeDouble(SymbolInfoDouble(symbol,SYMBOL_ASK)+Stop_Loss*point,digits);
      res=OrderModify(OrderTicket(),OrderOpenPrice(),sl,OrderTakeProfit(),0);
      if(!res)
        {
         int error=GetLastError();
         rezult=StringConcatenate(OrderSymbol(),": error modifying StopLoss order ",StrToType(OrderType())," - ",error," ",ErrorDescription(error)," Ticket: ",OrderTicket());
         Print(rezult);
        }
     }
  }
//+------------------------------------------------------------------+
void ModifyTP(string symbol,double Take_Profit)
  {
   if(Take_Profit<=0)return;
   double tp=0.0;
   bool res;
   double point=SymbolInfoDouble(symbol,SYMBOL_POINT);
   int digits=(int)SymbolInfoInteger(symbol,SYMBOL_DIGITS);
   int total=OrdersTotal();

   for(int i=0; i<total; i++)
     {
      if(!OrderSelect(i,SELECT_BY_POS))continue;
      if(OrderMagicNumber()!=Magic)continue;
      if(OrderSymbol()!=symbol)continue;
      if(OrderType()>1)continue;
      if(OrderTakeProfit()!=0)continue;

      if(OrderType()==OP_BUY) tp=NormalizeDouble(SymbolInfoDouble(symbol,SYMBOL_BID)+Take_Profit*point,digits);
      if(OrderType()==OP_SELL) tp=NormalizeDouble(SymbolInfoDouble(symbol,SYMBOL_ASK)-Take_Profit*point,digits);
      res=OrderModify(OrderTicket(),OrderOpenPrice(),OrderStopLoss(),tp,0);
      if(!res)
        {
         int error=GetLastError();
         rezult=StringConcatenate(OrderSymbol(),": error modifying TakeProfit order ",StrToType(OrderType())," - ",error," ",ErrorDescription(error)," Ticket: ",OrderTicket());
         Print(rezult);
        }
     }
  }
//+------------------------------------------------------------------+
void Trailing_Stop(string symbol,double Stop_Loss)
  {
   if(Stop_Loss<=0)return;
   double sl=0.0;
   double bid=SymbolInfoDouble(symbol,SYMBOL_BID);
   double ask=SymbolInfoDouble(symbol,SYMBOL_ASK);
   double point=SymbolInfoDouble(symbol,SYMBOL_POINT);
   int digits=(int)SymbolInfoInteger(symbol,SYMBOL_DIGITS);
   int total=OrdersTotal();
   for(int i=0; i<total; i++)
     {
      if(!OrderSelect(i,SELECT_BY_POS))continue;
      if(OrderMagicNumber()!=Magic)continue;
      if(OrderSymbol()!=symbol)continue;
      if(OrderType()>1)continue;

      if(OrderType()==OP_BUY)
        {
         sl=NormalizeDouble(bid-Stop_Loss*point,digits);
         if(sl<=OrderStopLoss())continue;
        }
      if(OrderType()==OP_SELL)
        {
         sl=NormalizeDouble(ask+Stop_Loss*point,digits);
         if(sl>=OrderStopLoss())continue;
        }
      bool res=OrderModify(OrderTicket(),OrderOpenPrice(),sl,OrderTakeProfit(),0);
      if(!res)
        {
         int error=GetLastError();
         rezult=StringConcatenate(OrderSymbol(),": error Trailing modifying StopLoss order ",StrToType(OrderType())," - ",error," ",ErrorDescription(error)," Ticket: ",OrderTicket());
         Print(rezult);
        }
     }
  }
//+------------------------------------------------------------------+
bool disabled(string symbol)
  {
   if(SymbolInfoInteger(symbol,SYMBOL_TRADE_MODE)==SYMBOL_TRADE_MODE_DISABLED)return(false);
   if(!TerminalInfoInteger(TERMINAL_TRADE_ALLOWED))return(false);
   if(!MQLInfoInteger(MQL_TRADE_ALLOWED))return(false);
   if(!AccountInfoInteger(ACCOUNT_TRADE_EXPERT))return(false);
   if(!AccountInfoInteger(ACCOUNT_TRADE_ALLOWED))return(false);
   return(true);
  }
//+------------------------------------------------------------------+
void from_create1()
  {
   if(IsVisualMode())
     {
      Width=300;
      Height=50;
     }

   int i=0;
   int x = Width-20;
   int y = 0;


   RectLabelCreate(0,form1+(string)i,0,0,0,Width,20,clrDodgerBlue,BORDER_RAISED);i++;
   BitmapLabelCreate(0,form1+(string)i,0,x,y,CloseOff,CloseDisable,0,0,0,0,show_close);i++;x-=18;
   BitmapLabelCreate(0,form1+(string)i,0,x,y,RollOn,RollOff,0,0,0,0,show_roll);i++;x-=18;
   BitmapLabelCreate(0,form1+(string)i,0,x,y+2,TurnOff,TurnOn,0,0,0,0,show_turn);i++;x-=18;
   LabelCreate(0,form1+(string)i,0,15,2,TimeToStr(TimeCurrent(),TIME_DATE|TIME_SECONDS)+" : "+DayOfWeekString(),10,clrBlack);i++;

  }
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
void from_create2()
  {

   int i=0;
   int x = 50;
   int y = 0;
   RectLabelCreate(0,form1+(string)i,0,10,0,60,20,clrDodgerBlue,BORDER_RAISED);i++;
   BitmapLabelCreate(0,form1+(string)i,0,x,y,CloseOff,CloseDisable,0,0,0,0,show_close);i++;x-=18;
   BitmapLabelCreate(0,form1+(string)i,0,x,y,RollOn,RollOff,0,0,0,0,show_roll);i++;x-=18;
   BitmapLabelCreate(0,form1+(string)i,0,x,y+2,TurnOff,TurnOn,0,0,0,0,show_turn);i++;x-=18;
  }
//+------------------------------------------------------------------+
void from_create3()
  {
   if(IsVisualMode())
     {
      Width=300;
      Height=50;
     }

   int i=0;
   int x = Width-20;
   int y = 0;


   RectLabelCreate(0,form1+(string)i,0,0,0,Width,20,clrDodgerBlue,BORDER_RAISED);i++;
   BitmapLabelCreate(0,form1+(string)i,0,x,y,CloseOff,CloseDisable,0,0,0,0,show_close);i++;x-=18;
   BitmapLabelCreate(0,form1+(string)i,0,x,y,RollOn,RollOff,0,0,0,0,show_roll);i++;x-=18;
   BitmapLabelCreate(0,form1+(string)i,0,x,y+2,TurnOff,TurnOn,0,0,0,0,show_turn);i++;x-=18;
   LabelCreate(0,form1+(string)i,0,15,2,TimeToStr(TimeCurrent(),TIME_DATE|TIME_SECONDS)+" : "+DayOfWeekString(),10,clrBlack);i++;

   i=10;
   x = 5;
   y = 25;

   RectLabelCreate(0,form2+(string)i,0,0,20,Width,Height,clrWhiteSmoke,BORDER_SUNKEN);i++;

   for(int n=0;n<total_symbol;n++)
     {
      if(IsVisualMode()){LabelCreate(0,form2+(string)i,0,x,y,_Symbol,10,clrGreen);i++;}
      else {LabelCreate(0,form2+(string)i,0,x,y,SymbolName(n,MarketWatch),10,clrGreen);i++;}
      LabelCreate(0,form2+(string)i,0,x+100,y,":",10,ColorText);i++;
      LabelCreate(0,form2+(string)i,0,x+140,y,CharToStr((uchar)arrow(Trend[n])),10,Colorarrow(Trend[n]),"Wingdings");i++;

      LabelCreate(0,form2+(string)i,0,x+160,y,":",10,ColorText);i++;
      LabelCreate(0,form2+(string)i,0,x+210,y,CharToStr((uchar)arrow(Signal[n])),10,Colorarrow(Signal[n]),"Wingdings");i++;

      y+=15;
      if(y>=Height-20)
        {
         x+=250;
         y=25;
        }
     }

  }
//+------------------------------------------------------------------+
int arrow(int sig)
  {
   if(sig==EMPTY)return(251);
   if(sig==OP_BUY)return(233);
   if(sig==OP_SELL)return(234);
   return(0);
  }
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
int Colorarrow(int sig)
  {
   if(sig==EMPTY)return(clrMediumAquamarine);
   if(sig==OP_BUY)return(clrBlue);
   if(sig==OP_SELL)return(clrRed);
   return(0);
  }
//+------------------------------------------------------------------+
string  DayOfWeekString()
  {
   switch(DayOfWeek())
     {
      case 0: return("");
      case 1: return("");
      case 2: return("");
      case 3: return("");
      case 4: return("");
      case 5: return("");
      case 6: return("");
     }
   return(NULL);
  }
//+------------------------------------------------------------------+
bool ButtonCreate(const long              chart_ID=0,// ID 
                  const string            name="Button",            //  
                  const int               sub_window=0,             //  
                  const int               x=0,                      //    X
                  const int               y=0,                      //    Y
                  const int               width=50,                 //  
                  const int               height=18,                //  
                  const string            text="Button",            // 
                  const int               font_size=10,             //  
                  const bool              state=false,              // /
                  const color             clr=clrBlack,             //  
                  const color             back_clr=C'236,233,216',  //  
                  const color             border_clr=clrNONE,       //  
                  const ENUM_BASE_CORNER  corner=CORNER_LEFT_UPPER, //                     
                  const string            font="Arial",             //                  
                  const bool              back=false,               //   
                  const bool              selection=false,          //   
                  const bool              hidden=true,              //    
                  const long              z_order=0)                //    
  {
//---   
   ResetLastError();
//---  
   if(ObjectFind(chart_ID,name)!=sub_window)
     {
      if(!ObjectCreate(chart_ID,name,OBJ_BUTTON,sub_window,0,0))
        {
         Print(__FUNCTION__,
               ": Error Code = ",GetLastError());
         return(false);
        }
     }
//---   
   ObjectSetInteger(chart_ID,name,OBJPROP_XDISTANCE,x);
   ObjectSetInteger(chart_ID,name,OBJPROP_YDISTANCE,y);
//---   
   ObjectSetInteger(chart_ID,name,OBJPROP_XSIZE,width);
   ObjectSetInteger(chart_ID,name,OBJPROP_YSIZE,height);
//---   ,      
   ObjectSetInteger(chart_ID,name,OBJPROP_CORNER,corner);
//---  
   ObjectSetString(chart_ID,name,OBJPROP_TEXT,text);
//---   
   ObjectSetString(chart_ID,name,OBJPROP_FONT,font);
//---   
   ObjectSetInteger(chart_ID,name,OBJPROP_FONTSIZE,font_size);
//---   
   ObjectSetInteger(chart_ID,name,OBJPROP_COLOR,clr);
//---   
   ObjectSetInteger(chart_ID,name,OBJPROP_BGCOLOR,back_clr);
//---   
   ObjectSetInteger(chart_ID,name,OBJPROP_BORDER_COLOR,border_clr);
//---    (false)   (true) 
   ObjectSetInteger(chart_ID,name,OBJPROP_BACK,back);
//---     
   ObjectSetInteger(chart_ID,name,OBJPROP_STATE,state);
//---  (true)   (false)    
   ObjectSetInteger(chart_ID,name,OBJPROP_SELECTABLE,selection);
   ObjectSetInteger(chart_ID,name,OBJPROP_SELECTED,selection);
//---  (true)   (false)      
   ObjectSetInteger(chart_ID,name,OBJPROP_HIDDEN,hidden);
//---         
   ObjectSetInteger(chart_ID,name,OBJPROP_ZORDER,z_order);
//---  
   return(true);
  }
//+------------------------------------------------------------------+
bool RectLabelCreate(const long             chart_ID=0,// ID 
                     const string           name="RectLabel",         //  
                     const int              sub_window=0,             //  
                     const int              x=0,                      //    X
                     const int              y=0,                      //    Y
                     const int              width=50,                 // 
                     const int              height=18,                // 
                     const color            back_clr=C'236,233,216',  //  
                     const ENUM_BORDER_TYPE border=BORDER_SUNKEN,     //  
                     const color            clr=clrRed,               //    (Flat)
                     const int              line_width=1,             //   
                     const ENUM_BASE_CORNER corner=CORNER_LEFT_UPPER, //    

                     const ENUM_LINE_STYLE  style=STYLE_SOLID,//   

                     const bool             back=false,               //   
                     const bool             selection=false,          //   
                     const bool             hidden=true,              //    
                     const long             z_order=0)                //    
  {
//---   
   ResetLastError();
//---   
   if(ObjectFind(chart_ID,name)!=sub_window)
     {
      if(!ObjectCreate(chart_ID,name,OBJ_RECTANGLE_LABEL,sub_window,0,0))
        {
         Print(__FUNCTION__,
               ": Error Code = ",GetLastError());
         return(false);
        }
     }
//---   
   ObjectSetInteger(chart_ID,name,OBJPROP_XDISTANCE,x);
   ObjectSetInteger(chart_ID,name,OBJPROP_YDISTANCE,y);
//---   
   ObjectSetInteger(chart_ID,name,OBJPROP_XSIZE,width);
   ObjectSetInteger(chart_ID,name,OBJPROP_YSIZE,height);
//---   
   ObjectSetInteger(chart_ID,name,OBJPROP_BGCOLOR,back_clr);
//---   
   ObjectSetInteger(chart_ID,name,OBJPROP_BORDER_TYPE,border);
//---   ,      
   ObjectSetInteger(chart_ID,name,OBJPROP_CORNER,corner);
//---     (  Flat)
   ObjectSetInteger(chart_ID,name,OBJPROP_COLOR,clr);
//---     
   ObjectSetInteger(chart_ID,name,OBJPROP_STYLE,style);
//---    
   ObjectSetInteger(chart_ID,name,OBJPROP_WIDTH,line_width);
//---    (false)   (true) 
   ObjectSetInteger(chart_ID,name,OBJPROP_BACK,back);
//---  (true)   (false)    
   ObjectSetInteger(chart_ID,name,OBJPROP_SELECTABLE,selection);
   ObjectSetInteger(chart_ID,name,OBJPROP_SELECTED,selection);
//---  (true)   (false)      
   ObjectSetInteger(chart_ID,name,OBJPROP_HIDDEN,hidden);
//---         
   ObjectSetInteger(chart_ID,name,OBJPROP_ZORDER,z_order);
//---  
   return(true);
  }
//+------------------------------------------------------------------+
bool BitmapLabelCreate(const long              chart_ID=0,// ID 
                       const string            name="BmpLabel",          //  
                       const int               sub_window=0,             //  
                       const int               x=0,                      //    X
                       const int               y=0,                      //    Y
                       const string            file_on="",               //    On
                       const string            file_off="",              //    Off
                       const int               width=0,                  // X-  
                       const int               height=0,                 // Y-  
                       const int               x_offset=10,              //     X
                       const int               y_offset=10,              //     Y
                       const bool              state=false,              // /
                       const color             clr=clrRed,               //    
                       const int               point_width=1,            //   
                       const ENUM_LINE_STYLE   style=STYLE_SOLID,        //    
                       const ENUM_BASE_CORNER  corner=CORNER_LEFT_UPPER, //    
                       const ENUM_ANCHOR_POINT anchor=ANCHOR_LEFT_UPPER, //                        

                       const bool              back=false,               //   
                       const bool              selection=false,          //   
                       const bool              hidden=true,              //    
                       const long              z_order=0)                //    
  {
//---   
   ResetLastError();
//---   
   if(ObjectFind(chart_ID,name)!=sub_window)
     {
      if(!ObjectCreate(chart_ID,name,OBJ_BITMAP_LABEL,sub_window,0,0))
        {
         Print(__FUNCTION__,
               ": Error Code = ",GetLastError());
         return(false);
        }
     }
//---     On  Off
   if(!ObjectSetString(chart_ID,name,OBJPROP_BMPFILE,0,file_on))
     {
      Print(__FUNCTION__,
            ":  Error Code = ",GetLastError());
      return(false);
     }
   if(!ObjectSetString(chart_ID,name,OBJPROP_BMPFILE,1,file_off))
     {
      Print(__FUNCTION__,
            ": Error Code = ",GetLastError());
      return(false);
     }
//---   
   ObjectSetInteger(chart_ID,name,OBJPROP_XDISTANCE,x);
   ObjectSetInteger(chart_ID,name,OBJPROP_YDISTANCE,y);
//---    ;     
//---      ()  , 
//---   ;        ,
//---     ,    
   ObjectSetInteger(chart_ID,name,OBJPROP_XSIZE,width);
   ObjectSetInteger(chart_ID,name,OBJPROP_YSIZE,height);
//--- ,        
//---       ;  
//---          
   ObjectSetInteger(chart_ID,name,OBJPROP_XOFFSET,x_offset);
   ObjectSetInteger(chart_ID,name,OBJPROP_YOFFSET,y_offset);
//--- ,      (  )
   ObjectSetInteger(chart_ID,name,OBJPROP_STATE,state);
//---   ,      
   ObjectSetInteger(chart_ID,name,OBJPROP_CORNER,corner);
//---   
   ObjectSetInteger(chart_ID,name,OBJPROP_ANCHOR,anchor);
//---        
   ObjectSetInteger(chart_ID,name,OBJPROP_COLOR,clr);
//---         
   ObjectSetInteger(chart_ID,name,OBJPROP_STYLE,style);
//---    ,      
   ObjectSetInteger(chart_ID,name,OBJPROP_WIDTH,point_width);
//---    (false)   (true) 
   ObjectSetInteger(chart_ID,name,OBJPROP_BACK,back);
//---  (true)   (false)    
   ObjectSetInteger(chart_ID,name,OBJPROP_SELECTABLE,selection);
   ObjectSetInteger(chart_ID,name,OBJPROP_SELECTED,selection);
//---  (true)   (false)      
   ObjectSetInteger(chart_ID,name,OBJPROP_HIDDEN,hidden);
//---         
   ObjectSetInteger(chart_ID,name,OBJPROP_ZORDER,z_order);
//---  
   return(true);
  }
//+------------------------------------------------------------------+
bool EditCreate(const long             chart_ID=0,// ID 
                const string           name="Edit",              //  
                const int              sub_window=0,             //  
                const int              x=0,                      //    X
                const int              y=0,                      //    Y
                const int              width=50,                 // 
                const int              height=18,                // 
                const string           text="Text",              // 
                const int              font_size=10,             //                  
                const color            clr=clrBlack,             //  
                const color            back_clr=clrWhite,        //  
                const ENUM_ALIGN_MODE  align=ALIGN_LEFT,//   
                const bool             read_only=true,//  
                const color            border_clr=clrNONE,       //  
                const ENUM_BASE_CORNER corner=CORNER_LEFT_UPPER, //    
                const string           font="Arial",             // 
                const bool             back=false,               //   
                const bool             selection=false,          //   
                const bool             hidden=true,              //    
                const long             z_order=0)                //    
  {
//---   
   ResetLastError();
//---   
   if(ObjectFind(chart_ID,name)!=sub_window)
     {
      if(!ObjectCreate(chart_ID,name,OBJ_EDIT,sub_window,0,0))
        {
         Print(__FUNCTION__,
               ": Error Code = ",GetLastError());
         return(false);
        }
     }
//---   
   ObjectSetInteger(chart_ID,name,OBJPROP_XDISTANCE,x);
   ObjectSetInteger(chart_ID,name,OBJPROP_YDISTANCE,y);
//---   
   ObjectSetInteger(chart_ID,name,OBJPROP_XSIZE,width);
   ObjectSetInteger(chart_ID,name,OBJPROP_YSIZE,height);
//---  
   ObjectSetString(chart_ID,name,OBJPROP_TEXT,text);
//---   
   ObjectSetString(chart_ID,name,OBJPROP_FONT,font);
//---   
   ObjectSetInteger(chart_ID,name,OBJPROP_FONTSIZE,font_size);
//---      
   ObjectSetInteger(chart_ID,name,OBJPROP_ALIGN,align);
//---  (true)   (false)    
   ObjectSetInteger(chart_ID,name,OBJPROP_READONLY,read_only);
//---   ,      
   ObjectSetInteger(chart_ID,name,OBJPROP_CORNER,corner);
//---   
   ObjectSetInteger(chart_ID,name,OBJPROP_COLOR,clr);
//---   
   ObjectSetInteger(chart_ID,name,OBJPROP_BGCOLOR,back_clr);
//---   
   ObjectSetInteger(chart_ID,name,OBJPROP_BORDER_COLOR,border_clr);
//---    (false)   (true) 
   ObjectSetInteger(chart_ID,name,OBJPROP_BACK,back);
//---  (true)   (false)    
   ObjectSetInteger(chart_ID,name,OBJPROP_SELECTABLE,selection);
   ObjectSetInteger(chart_ID,name,OBJPROP_SELECTED,selection);
//---  (true)   (false)      
   ObjectSetInteger(chart_ID,name,OBJPROP_HIDDEN,hidden);
//---         
   ObjectSetInteger(chart_ID,name,OBJPROP_ZORDER,z_order);
//---  
   return(true);
  }
//+------------------------------------------------------------------+
bool LabelCreate(const long              chart_ID=0,// ID 
                 const string            name="Label",             //  
                 const int               sub_window=0,             //  
                 const int               x=0,                      //    X
                 const int               y=0,                      //    Y
                 const string            text="Label",             // 
                 const int               font_size=10,             //  
                 const color             clr=clrRed,               // 
                 const string            font="Arial",             //  
                 const ENUM_BASE_CORNER  corner=CORNER_LEFT_UPPER, //     
                 const ENUM_ANCHOR_POINT anchor=ANCHOR_LEFT_UPPER, //                                                                  
                 const double            angle=0.0,                //                   
                 const bool              back=false,               //   
                 const bool              selection=false,          //   
                 const bool              hidden=true,              //    
                 const long              z_order=0)                //    
  {
//---   
   ResetLastError();
//---   
   if(ObjectFind(chart_ID,name)!=sub_window)
     {
      if(!ObjectCreate(chart_ID,name,OBJ_LABEL,sub_window,0,0))
        {
         Print(__FUNCTION__,
               ": Error Code = ",GetLastError());
         return(false);
        }
     }
//---   
   ObjectSetInteger(chart_ID,name,OBJPROP_XDISTANCE,x);
   ObjectSetInteger(chart_ID,name,OBJPROP_YDISTANCE,y);
//---   ,      
   ObjectSetInteger(chart_ID,name,OBJPROP_CORNER,corner);
//---  
   ObjectSetString(chart_ID,name,OBJPROP_TEXT,text);
//---   
   ObjectSetString(chart_ID,name,OBJPROP_FONT,font);
//---   
   ObjectSetInteger(chart_ID,name,OBJPROP_FONTSIZE,font_size);
//---    
   ObjectSetDouble(chart_ID,name,OBJPROP_ANGLE,angle);
//---   
   ObjectSetInteger(chart_ID,name,OBJPROP_ANCHOR,anchor);
//---  
   ObjectSetInteger(chart_ID,name,OBJPROP_COLOR,clr);
//---    (false)   (true) 
   ObjectSetInteger(chart_ID,name,OBJPROP_BACK,back);
//---  (true)   (false)    
   ObjectSetInteger(chart_ID,name,OBJPROP_SELECTABLE,selection);
   ObjectSetInteger(chart_ID,name,OBJPROP_SELECTED,selection);
//---  (true)   (false)      
   ObjectSetInteger(chart_ID,name,OBJPROP_HIDDEN,hidden);
//---         
   ObjectSetInteger(chart_ID,name,OBJPROP_ZORDER,z_order);
//---  
   return(true);
  }
//+------------------------------------------------------------------+
int ChartWidthInPixels(const long chart_ID=0)
  {
   long result=-1;
   ResetLastError();
   if(!ChartGetInteger(chart_ID,CHART_WIDTH_IN_PIXELS,0,result))
     {
      Print(__FUNCTION__+", Error Code = ",GetLastError());
     }
   return((int)result);
  }
//+------------------------------------------------------------------+
int ChartHeightInPixelsGet(const long chart_ID=0,const int sub_window=0)
  {
   long result=-1;
   ResetLastError();
   if(!ChartGetInteger(chart_ID,CHART_HEIGHT_IN_PIXELS,sub_window,result))
     {
      Print(__FUNCTION__+", Error Code = ",GetLastError());
     }
   return((int)result);
  }
//+------------------------------------------------------------------+
